import fi.jyu.mit.ohj2.*;

/**
 *  John McLane (Bruce Willis) joutui elokuvassa Die Hard 3 ongelman eteen,
 *  jossa piti kahdella vesikanisterilla mitata jonkin muun suuruinen
 *  vesimr "tarkasti" ja nin est pommin rjhtminen.
 *  Koska aika meni varsin tiukalle, on vastaavien tilanteiden harjoittelemiseksi
 *  nyt tehty uusi menestysohjelma "Astia".
 *<br>
 *  Pelill demonstroidaan/harjoitellaan miten voidaan kahdella astialla,
 *  5 l ja 8 l,  muodostaa kaikki mahdolliset tilavuudet 1-13 l.
 *  Peliss on kaksi varsinaista astiaa: a5 ja a8, sek kolmas apuastia
 *  ampari.  Nestett voidaan kerrallaan kaataa yhdest astiasta toiseen
 *  joko siten, ett astian koko sislt tyhjennetn jos se mahtuu
 *  tai astista kaadetaan sen verran ett toinen astia tulee tyteen.
 *<br>
 *  Tee ohjelma jota voitasiin kytt seuraavasti:
 *<br>
 *<pre>
 *  Kytsssi on 8 ja 5 litran astia ja mpri (100 l)
 *
 *  8 litran astiassa on 0 litraa
 *  5 litran astiassa on 0 litraa
 *  Mist kaadetaan ja mihin > 8[ret]
 *  8 litran astiassa on 8 litraa
 *  5 litran astiassa on 0 litraa
 *  Mist kaadetaan ja mihin >8 5[ret]
 *  8 litran astiassa on 3 litraa
 *  5 litran astiassa on 5 litraa
 *  Mist kaadetaan ja mihin >5 [ret]
 *  8 litran astiassa on 3 litraa
 *  5 litran astiassa on 0 litraa
 *  Mist kaadetaan ja mihin >8 5[ret]
 *  8 litran astiassa on 0 litraa
 *  5 litran astiassa on 3 litraa
 *  Mist kaadetaan ja mihin >[ret]
 *</pre>
 * @author  Vesa Lappalainen
 * @version 1.0, 09.02.2003
 */
public class Astia2 {
  private String nimi;
  private double tilavuus;
  private double maara;

  /**
   * Alustaa uuden astian tietyn kokoiseksi ja luonnollisetsi tyhjksi
   * @param nimi uuden astian nimi
   * @param tilavuus uuden astian tilavuus
   */
  public Astia2(String nimi, double tilavuus) {
    this.nimi = nimi;
    this.tilavuus = tilavuus; this.maara = 0;
  }

  /**
   * Tytt astian piripintaan asti
   */
  public void tayta() { maara = tilavuus; }


  /**
   * kaataa astiaan joko lis tai vhent, yli ei saa menn eik
   * pakkasen puolelle
   * @param lisa astiaan laitettava tai otettava nestemr
   */
  public void kaada(double lisa) {
    if ( lisa < 0 ) {
      if ( -lisa > maara ) maara = 0;
      else maara += lisa;
    }
    else
      if ( getTyhjaa() > lisa ) maara += lisa;
      else tayta();
  }

  /**
   * Kaataa tst astiasta (this) toiseen astiaan niin paljon kuin toiseen
   * mahtuu tai tst astiasta on antaa.
   * @param astia astia johon kaadetaan
   */
  public void kaada(Astia2 astia) {
    double siirrettava = astia.getTyhjaa();
    if ( getMaara() < siirrettava ) siirrettava = getMaara();
    astia.kaada(siirrettava);
    kaada(-siirrettava);
  }

  public double getMaara()           { return maara; }
  public double getTilavuus()        { return tilavuus; }
  public double getTyhjaa()          { return getTilavuus()-getMaara(); }
  public String getNimi()            { return nimi; }
  public boolean oletko(String mika) { return getNimi().equalsIgnoreCase(mika);}



  private static void tulosta_ohje(Astia2 astiat[])
  {
    if ( astiat.length <= 0 ) return;
    String ja="";
    System.out.print("Kytsssi on ");
    for ( int i=1; i<astiat.length; i++) {
      System.out.print(ja + astiat[i].getTilavuus());
      ja = " sek ";
    }
    System.out.println(" litran astiat ja mpari (" +
                       astiat[0].getTilavuus() + " l)");
  }

  /**
   * Etsii sen astian, jolla on annettu nimi.
   * @param astiat taulukko astoista, joista etsitn
   * @param nimi etsittvn astian nimi
   * @return astian indeksi taulukossa tai -1 jos ei lydy
   */
/*
  private static int etsi(Astia2 astiat[], String nimi)
  {
    for (int i=0; i<astiat.length; i++)
      if ( astiat[i].oletko(nimi) ) return i;
    return -1;
  }
*/
  private static Astia2 etsi(Astia2 astiat[], String nimi) {
    for (int i = 0; i < astiat.length; i++)
      if (astiat[i].oletko(nimi)) return astiat[i];
    return null;
  }

  private static void nimi_ohje(Astia2 astiat[],String mista, String mihin) {
    if ( !mista.equals("?") )
      System.out.println("Nime ei tunneta: " + mista + " tai " + mihin);
    System.out.println("Tunnetaan nimet: ");
    for ( int i=0; i<astiat.length; i++)
      System.out.print(astiat[i].getNimi() + " ");
    System.out.println("");
  }


  public static void main(String[] args) {
    Astia2 astiat[]  = { new SuperAstia(""), new Astia2("5",5), new Astia2("8",8), new Astia2("13",13) };

    // int luvut[] = {1,2,3};

    Astia2 ampari = astiat[0];
    ampari.tayta();  // astiat[0].tayta();

    tulosta_ohje(astiat);

    while ( true ) {
      for ( int i=1; i<astiat.length; i++)
        System.out.println(astiat[i].getTilavuus() + " litran astiassa on " +
                           astiat[i].getMaara() + " litraa nestett");
      String rivi = Syotto.kysy("Mist kaadetaan ja mihin");
      if ( rivi.length() == 0 ) break;
      StringBuffer sb = new StringBuffer(rivi);
      String smista = Mjonot.erota(sb);
      String smihin = Mjonot.erota(sb);
/*
      int imista = etsi(astiat,mista);
      int imihin = etsi(astiat,mihin);

      if ( ( imista < 0 ) || ( imihin < 0 ) ) nimi_ohje(astiat,mista, mihin);
      else astiat[imista].kaada(astiat[imihin]);
*/
      Astia2 mista = etsi(astiat,smista);
      Astia2 mihin = etsi(astiat,smihin);
      if ( mista == null || mihin == null ) nimi_ohje(astiat,smista, smihin);
      else mista.kaada(mihin);
    }
  }

}


class SuperAstia extends Astia2 {
  SuperAstia(String nimi) {
    super(nimi,0);
  }

  public void kaada(Astia2 astia) {
    double siirrettava = astia.getTyhjaa();
    astia.kaada(siirrettava);
  }

  public double getTyhjaa() { return Double.POSITIVE_INFINITY; /* ??? */ }
}
